using System;
using System.Linq;
using System.Collections.Generic;

class Solution {
    static (int, int) Solve(long p, long q)
    {
       
        for (int n = 1; n <= Math.Sqrt(p + q) + 1; n++)
        {
            for (int m = n; m <= Math.Sqrt(p + q) + 1; m++)
            {
                long tv = 0;
                long tu = 0;
                int currentN = n;
                int currentM = m;
                bool ch = true;

               
                while (currentN > 0 && currentM > 0)
                {
                   
                    int size = Math.Min(currentN, currentM);
                    long area = (long)size * size;

                    if (ch)
                    {
                        tv += area;
                    }
                    else
                    {
                        tu += area;
                    }

                    
                    if (currentN > currentM)
                    {
                        currentN -= size;
                    }
                    else
                    {
                        currentM -= size;
                    }

                  
                    ch = !ch;
                }

               
                if (tv == p && tu == q)
                {
                    return (n, m);
                }
            }
        }

      
        return (-1, -1);
    }

    static void Main()
    {
 
        var input = Console.ReadLine().Split();
        long p = long.Parse(input[0]);
        long q = long.Parse(input[1]);

        
        var result = Solve(p, q);

        if (result == (-1, -1))
        {
            Console.WriteLine(-1);
        }
        else
        {
            Console.WriteLine($"{result.Item1} {result.Item2}");
        }
    }
}
