MATCH_N = [6, 2, 5, 5, 4, 5, 6, 3, 7, 6]


def find_solution_set(n) -> list[tuple[int, int]]:
    """Find a set of all correct equations a + b = n,
    return a list of possibilities (a, b)"""

    results = []
    for a in range(0, n+1):
        b = n - a
        results.append((a, b))
    
    return results


def find_solution(a, b, c):
    
    # edge case when the equation is already correct
    if a + b == c:
        return True
    
    match_amount_current = MATCH_N[a] + MATCH_N[b]
    
    correct_solution_set = find_solution_set(c)
    for solution in correct_solution_set:
        sa, sb = solution
        match_amount_correct = MATCH_N[sa] + MATCH_N[sb]
        if match_amount_correct == match_amount_current:
            return True

    return False


a, b, c = map(int, input().split())

ans = find_solution(a, b, c)

if ans:
    print('Yes')
else:
    print('No')
