def abs(a, b) -> int:
    """Absolute value of the difference, i forgot
    what the function is in math module (>_<)"""

    if a > b:
        return a - b
    
    return b - a


def represent_as_squares(n) -> list[int]:
    """Represent a number as a sum of square numbers"""

    biggest_square = (n ** 0.5) // 1  # square root floored
    remainder = n - biggest_square ** 2

    if remainder != 0:
        remainder_squares = represent_as_squares(remainder)
        result = [biggest_square] + remainder_squares
    else:
        result = [biggest_square]
    
    return [x for x in result if x != 0]


def is_rect_formation_possible(v) -> tuple|None:
    """Is rectangular formation possile for a set of squares,
    represented as a list (where each value is the side of the square),
    returns the sides of the rectange or None if not possible"""

    side = max(v)
    side2 = side * v.count(side)

    remainder = [x for x in v if x != side]

    if len(remainder) == 0:
        return (side, side2)

    remainder_formation = is_rect_formation_possible(remainder)
    if remainder_formation is None: return None
    else:
        rside, rside2 = remainder_formation
        if side == rside: return (side, side2 + rside2)
        if side == rside2: return (side, side2 + rside)
        if side2 == rside: return (side2, side + rside2)
        if side2 == rside2: return (side2, side + rside)

    return None


p, q = map(int, input().split())

ps = represent_as_squares(p)
qs = represent_as_squares(q)

# print(ps, qs)


def solve(p, q, ps, qs) -> tuple:
    """Final steps as a function to use guard clauses"""

    # First guy always takes more
    if p < q:
        return (-1,)

    if abs(len(ps), len(qs)) > 1:
        return (-1,)

    side = max(ps)

    side2 = (p + q) / side
    if side2 // 1 == side2:
        if is_rect_formation_possible(ps + qs) is not None:
            return (int(side), int(side2))

    return (-1,)


print(*solve(p, q, ps, qs))