def abs(a, b) -> int:
    """Absolute value of the difference, i forgot
    what the function is in math module (>_<)"""

    if a > b:
        return a - b
    
    return b - a


def represent_as_squares(n) -> list[int]:
    """Represent a number as a sum of square numbers"""

    biggest_square = (n ** 0.5) // 1  # square root floored
    remainder = n - biggest_square ** 2

    if remainder != 0:
        remainder_squares = represent_as_squares(remainder)
        result = [biggest_square] + remainder_squares
    else:
        result = [biggest_square]
    
    return [x for x in result if x != 0]


def is_rect_formation_possible(v) -> tuple|None:
    """Is rectangular formation possile for a set of squares,
    represented as a list (where each value is the side of the square),
    returns the sides of the rectange or None if not possible"""

    side = max(v)
    side2 = side * v.count(side)

    remainder = [x for x in v if x != side]

    if len(remainder) == 0:
        return (side, side2)

    remainder_formation = is_rect_formation_possible(remainder)
    if remainder_formation is None: return None
    else:
        rside, rside2 = remainder_formation
        if side == rside: return (side, side2 + rside2)
        if side == rside2: return (side, side2 + rside)
        if side2 == rside: return (side2, side + rside2)
        if side2 == rside2: return (side2, side + rside)

    return None


def check_order(a, b) -> bool:
    """Check that the order of cake cuts is correct,
    from biggest to smallest with guys alternating.
    NOTE: modifies the lists internally!"""

    # Assuming `a` and `b` already sorted in decreasing order
    if len(b) < len(a): b.append(-1)
    result = []
    for i in range(len(a)):
        # result += [a[i], b[i]]
        result.append(a[i])
        result.append(b[i])
    
    return result == sorted(result)[::-1]


p, q = map(int, input().split())

ps = represent_as_squares(p)
qs = represent_as_squares(q)

# print(ps, qs)


def solve(p, q, ps, qs) -> tuple:
    """Final steps as a function to use guard clauses"""

    # First guy always takes more
    if p < q:
        return (-1,)

    if abs(len(ps), len(qs)) > 1:
        return (-1,)

    formation = is_rect_formation_possible(ps + qs)
    if formation is None:
        return (-1,)

    if not check_order(ps, qs):
        return (-1,)

    return map(int, formation)


print(*solve(p, q, ps, qs))