def simulate(n, m) -> list:
    """Simulate cake n x m and check which
    p and q can you get"""

    def step(n, m):
        return (n, m-n, n**2)
    
    score = [0, 0]
    turn = 0
    a = 0
    while True:
        n, m, inc = step(n, m)
        n, m = min(n, m), max(n, m)
        score[turn] += inc
        turn = [1, 0][turn]

        if n == 0:
            break

    return score


def solve(p, q):

    # First guy will always have more cake
    if q > p:
        return (-1,)

    diff_pq = p - q
    sum_pq = p + q

    n = (diff_pq+1)/2

    for n in range(int((n**0.5) // 1 + 1), int((n+0.5) // 1 + 1)):
        m = sum_pq / n
        if m == m // 1:
            n, m = int(n), int(m)
            if simulate(n, m) == [p, q]:
                return (n, m)
    
    return (-1,)


p, q = map(int, input().split())
print(*solve(p, q))