fn main() {
    let mut input = String::new();

    std::io::stdin()
        .read_line(&mut input)
        .expect("Failed to read line");

    let [a, b, c]: [u8; 3] = input
        .trim()
        .split(" ")
        .map(|x| x.trim().parse().unwrap())
        .collect::<Vec<_>>()
        .try_into()
        .unwrap();

    let sum_of_matches = matches_of_number(a) + matches_of_number(b);

    let is_possible = possible_sums(sum_of_matches)
        .into_iter()
        .filter(|&x| x == c)
        .count() > 0;

    println!("{}", if is_possible { "Yes" } else { "No" })
}

fn possible_sums(match_num: u8) -> Vec<u8> {
    match match_num {
        0 | 1 | 2 | 3 => vec![],
        4 => vec![2],
        5 => vec![8],
        6 => vec![14, 5],
        7 => vec![3, 4, 6, 11],
        8 => vec![1, 7, 10, 9, 12, 8],
        9 => vec![9, 7, 13, 16, 6, 9],
        10 => vec![15, 13, 4, 5, 7, 6, 8, 10],
        11 => vec![12, 2, 3, 5, 8, 9, 11, 14],
        12 => vec![10, 11, 13, 0, 6, 9, 12, 15, 18],
        13 => vec![8, 14, 17],
        14 => vec![16],
        _ => vec![]
    }
}

fn matches_of_number(num: u8) -> u8 {
    match num {
        0 | 6 | 9 => 6,
        1 => 2,
        2 | 3 | 5 => 5,
        4 => 4,
        7 => 3,
        8 => 7,
        _ => panic!("Number is larger than 9")
    }
}