fn main() {
    let mut input = String::new();

    std::io::stdin()
        .read_line(&mut input)
        .expect("Failed to read line");

    let [p, q]: [u32; 2] = input
        .trim()
        .split(" ")
        .map(|x| x.trim().parse().unwrap())
        .collect::<Vec<_>>()
        .try_into()
        .unwrap();

    let total_area = p + q;

    if p == 0 {
        println!("{} {}", sqrt(q), sqrt(q));
        return
    }
    if q == 0 {
        println!("{} {}", sqrt(p), sqrt(p));
        return
    }

    let first_square = sqrt(p.max(q) - p.min(q));

    if total_area % first_square != 0 {
        println!("-1");
        return
    }

    println!("{} {}", first_square, total_area/first_square)
}

/*
p*q

p.max(q)-p.min(q) * p.min(q)



*/

fn sqrt(num: u32) -> u32 {
    (0..=num).take_while(|x| x*x <= num).last().unwrap()
}