#include <iostream>

using namespace std;
using ll = long long;

pair<ll, ll> play_game(ll a, ll b, int first_move = 0) {
    if (a == 0 || b == 0) {
        return { 0, 0 };
    }

    if (a > b) {
        swap(a, b);
    }
    
    auto [inner_p, inner_q] = play_game(a, b % a, ((b / a) % 2) == 0 ? first_move : (1 - first_move));

    return {
        a * a * ((b / a + (1 - first_move)) / 2) + inner_p,
        a * a * ((b / a + first_move) / 2) + inner_q,
    };
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll p, q;
    cin >> p >> q;
    
    ll area = p + q;
    
    for (ll a = 1; a * a <= area; a++) {
        if (area % a != 0) {
            continue;
        }

        ll b = area / a;

        auto [try_p, try_q] = play_game(a, b);

        if (try_p == p && try_q == q) {
            cout << a << " " << b << "\n";
            return 0;
        }
    }

    cout << "-1\n";

    return 0;
}
