#include <bits/stdc++.h>
using namespace std;;

pair<int, int> get_min_dist(const string& s) {
    vector<int> last(10, -1);
    int min_dist = s.length();
    int min_count = 0;

    for (int i = 0; i < s.length(); i++) {
        int digit = s[i] - '0';

        if (last[digit] >= 0) {
            int dist = i - last[digit] - 1;

            if (dist < min_dist) {
                min_dist = dist;
                min_count = 1;
            } else if (dist == min_dist) {
                min_count += 1;
            }
        }

        last[digit] = i;
    }

    return { min_dist, min_count };
}

// bool solve() {
//     int n;
//     cin >> n;
//     string s;
//     cin >> s;

//     if (s.length() == 2 && s[0] == s[1]) {
//         return false;
//     } else if (s.length() <= 1) {
//         return true;
//     } else if (get_min_dist(s).first <= 0) {
//         return false;
//     } 

//     while (true) {
//         pair<int, int> max_dist = { -1, s.length() + 1 };
//         string best_candidate;

//         for (int i = 0; i < s.length(); i++) {
//             string candidate = s.substr(0, i) + s.substr(i + 1, s.length());

//             auto dist = get_min_dist(candidate);

//             if (dist.first > max_dist.first || (dist.first == max_dist.first && dist.second > max_dist.second)) {
//                 max_dist = dist;
//                 best_candidate = candidate;
//             }
//         }

//         s = best_candidate;

//         if (s.length() <= 1) {
//             return true;
//         } else if (max_dist.first <= 0) {
//             return false;
//         }

//         pair<int, int> min_dist = { s.length() + 1, s.length() + 1 };

//         for (int i = 0; i < s.length(); i++) {
//             string candidate = s.substr(0, i) + s.substr(i + 1, s.length());

//             auto dist = get_min_dist(candidate);

//             if (dist.first < max_dist.first || (dist.first == max_dist.first && dist.second > max_dist.second)) {
//                 max_dist = dist;
//                 best_candidate = candidate;
//             }
//         }

//         s = best_candidate;

//         if (s.length() <= 1) {
//             return true;
//         } else if (max_dist.first <= 0) {
//             return false;
//         }
//     }
// }

map<string, bool> cache{};

bool is_win(string s, int player = 0) {
    if (s.length() <= 1) {
        cache[s] = true;
        return player == 0;
    }

    if (cache.find(s) != cache.end()) {
        return player == 0 ? cache[s] : !cache[s];
    }

    for (int i = 0; i < s.length() - 1; i++) {
        if (s[i] == s[i + 1]) {
            cache[s] = false;
            return player == 1;
        }
    }

    for (int i = 0; i < s.length(); i++) {
        if (!is_win(s.substr(0, i) + s.substr(i + 1, s.length()), 1 - player)) {
            cache[s] = player == 0;
            return true;
        }
    }

    cache[s] = player == 1;
    return false;
}

bool solve() {
    int n;
    string s;
    cin >> n >> s;

    return is_win(s);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--) {
        cout << (solve() ? "Yes" : "No") << "\n";
    }
}

/*
0 #....#
...
7 #....#
8 #|.|.#
9 #.|.|#
   8989

each digit in 10 segments
move: merge 2, decrease 10 by 1
game end: 0 segment exists

10101001

156156

101
*/
