#include <bits/stdc++.h>
using namespace std;

pair<int, int> get_min_dist(const string& s) {
    vector<int> last(10, -1);
    int min_dist = s.length();
    int min_count = 0;

    for (int i = 0; i < s.length(); i++) {
        int digit = s[i] - '0';

        if (last[digit] >= 0) {
            int dist = i - last[digit] - 1;

            if (dist < min_dist) {
                min_dist = dist;
                min_count = 1;
            } else if (dist == min_dist) {
                min_count += 1;
            }
        }

        last[digit] = i;
    }

    return { min_dist, min_count };
}

bool solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;

    if (s.length() == 2 && s[0] == s[1]) {
        return false;
    } else if (s.length() <= 1) {
        return true;
    } else if (get_min_dist(s).first <= 0) {
        return false;
    } 

    while (true) {
        pair<int, int> max_dist = { -1, s.length() + 1 };
        string best_candidate;

        for (int i = 0; i < s.length(); i++) {
            string candidate = s.substr(0, i) + s.substr(i + 1, s.length());

            auto dist = get_min_dist(candidate);

            if (dist.first > max_dist.first || (dist.first == max_dist.first && dist.second > max_dist.second)) {
                max_dist = dist;
                best_candidate = candidate;
            }
        }

        s = best_candidate;

        if (s.length() <= 1) {
            return true;
        } else if (max_dist.first <= 0) {
            return false;
        }

        pair<int, int> min_dist = { s.length() + 1, s.length() + 1 };

        for (int i = 0; i < s.length(); i++) {
            string candidate = s.substr(0, i) + s.substr(i + 1, s.length());

            auto dist = get_min_dist(candidate);

            if (dist.second > max_dist.second || (dist.second == max_dist.second && dist.first < max_dist.first)) {
                max_dist = dist;
                best_candidate = candidate;
            }
        }

        s = best_candidate;

        if (s.length() <= 1) {
            return true;
        } else if (max_dist.first <= 0) {
            return false;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--) {
        cout << (solve() ? "Yes" : "No") << "\n";
    }
}