#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> adj;

int dfs(int cur, int pr) {
    for (int ad : adj[cur]) {
        if (ad != pr) {
            return dfs(ad, cur) + 1;
        }
    }
    return 1;
}

void dfs1(int node, int pr) {
    for (int ad : adj[node]) {
        if (ad != pr) {
            dfs1(ad, node);
        }
    }
    printf("%i ", node);
}

void dfs2(int node, int pr) {
    printf("%i ", node);
    for (int ad : adj[node]) {
        if (ad != pr) {
            dfs2(ad, node);
        }
    }
}

void doprint(int node, int child1, int child2) {
    dfs1(child1, node);
    printf("%i ", node);
    dfs2(child2, node);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    
    adj.assign(n + 1, {});
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    int node = -1;
    for (int i = 1; i <= n; i++) {
        if (adj[i].size() >= 3) {
            node = i;
        }
    }

    vector<pair<int, int>> kids;
    kids.reserve((int)adj[node].size());

    for (int ad : adj[node]) {
        kids.push_back({dfs(ad, node), ad});
    }
    sort(kids.begin(), kids.end(), greater<pair<int, int>>());

    printf("%i\n", kids[0].first + kids[1].first + 1);
    doprint(node, kids[0].second, kids[1].second);
    printf("\n");

    if (adj[node].size() >= 4 &&
     kids[2].first + kids[3].first ==
      kids[0].first + kids[1].first) {
        doprint(node, kids[2].second, kids[3].second);
        printf("\n");
      }
    else if (adj[node].size() >= 3 &&
     kids[2].first == kids[1].first) {
        doprint(node, kids[0].second, kids[2].second);
        printf("\n");
      }
    else {
        doprint(node, kids[0].second, kids[1].second);
        printf("\n");
    }





    
    
}
