#include <iostream>
#include <algorithm>
using namespace std;

pair<long long, long long> sim(long long a, long long b) {
    long long areaV = 0, areaU = 0;
    int turn = 0;
    
    while (a != b) {
        if (a < b)
            swap(a, b);

        long long q = a / b;

        if (a % b == 0) {
            long long full = q - 1;
            if (full > 0) {
                if (turn == 0) {
                    long long moves_curr = (full + 1) / 2;
                    long long moves_other = full / 2;
                    areaV += moves_curr * b * b;
                    areaU += moves_other * b * b;
                } else {
                    long long moves_curr = (full + 1) / 2;
                    long long moves_other = full / 2;
                    areaU += moves_curr * b * b;
                    areaV += moves_other * b * b;
                }
                if (full % 2 == 1)
                    turn = 1 - turn;
            }
            a = b; 
            
            if (turn == 0)
                areaV += a * a;
            else
                areaU += a * a;
            break;
        } else {
            long long full = q;
            if (turn == 0) {
                long long moves_curr = (full + 1) / 2;
                long long moves_other = full / 2;
                areaV += moves_curr * b * b;
                areaU += moves_other * b * b;
            } else {
                long long moves_curr = (full + 1) / 2;
                long long moves_other = full / 2;
                areaU += moves_curr * b * b;
                areaV += moves_other * b * b;
            }
            if (full % 2 == 1)
                turn = 1 - turn;
            a -= full * b;
        }
    }
    if (a == b) {
        if (turn == 0)
            areaV += a * a;
        else
            areaU += a * a;
    }
    return {areaV, areaU};
}

int main(){
    long long p, q;
    cin >> p >> q;

    long long sum = p + q;

    for (long long d = 1; d * d <= sum; d++) {
        if (sum % d != 0)
            continue;

        {
            long long m = d, n = sum / d;
            if (n < m)
                swap(n, m);
            auto outcome = sim(n, m);
            if (outcome.first == p && outcome.second == q) {
                cout << n << " " << m;
                return 0;
            }
        }
        
        if (d * d != sum) {
            long long m = sum / d, n = d;
            if (n < m)
                swap(n, m);
            auto outcome = sim(n, m);
            if (outcome.first == p && outcome.second == q) {
                cout << n << " " << m << "\n";
                return 0;
            }
        }
    }

    cout << -1;
    return 0;
}