#include <iostream>
#include <algorithm>
using namespace std;
 
pair<long long, long long> sim(long long n, long long m) {
    long long areaV = 0, areaU = 0;
    int turn = 0;
    long long a = n, b = m;
    
    while (true) {
        if (a < b)
            swap(a, b);
        
        if (a == b) {
            if (turn == 0)
                areaV += a * a;
            else
                areaU += a * a;
            break;
        }
        if (turn == 0)
            areaV += b * b;
        else
            areaU += b * b;
 
        a -= b;
        turn = 1 - turn;
    }
    return {areaV, areaU};
}
 
int main(){    
    long long p, q;
    cin >> p >> q;
    
    long long sum = p + q;
 
    for (long long d = 1; d * d <= sum; d++) {
        if (sum % d != 0) continue;
        
        long long m = d, n = sum / d;
        if (n < m) swap(n, m);
        auto simulated = sim(n, m);
        if (simulated.first == p && simulated.second == q) {
            cout << n << " " << m;
            return 0;
        }
        
        if (d * d != sum) {
            long long m = sum / d, n = d;
            if (n < m) swap(n, m);
            auto outcome = sim(n, m);
            if (outcome.first == p && outcome.second == q) {
                cout << n << " " << m << "\n";
                return 0;
            }
        }
    }
    
    cout << -1;
    return 0;
}