#include <iostream>
#include <algorithm>
using namespace std;
 
void calcOutcome(long long n, long long m, int turn, 
                 long long &areaV, long long &areaU) {
    if(n < m)
        swap(n, m);
    
    while (true) {
        if(n == m) {
            
            if(turn == 0)
                areaV += n * n;
            else
                areaU += n * n;
            break;
        }
        
        long long k = (n - 1) / m;
        
        long long cntCurrent = (k + 1) / 2;
        long long cntOpp = k / 2;
        
        if(turn == 0) {
            areaV += cntCurrent * m * m;
            areaU += cntOpp * m * m;
        } else {
            areaU += cntCurrent * m * m;
            areaV += cntOpp * m * m;
        }
       
       if(k % 2 == 1)
            turn = 1 - turn;
 
  n -= k * m;
 
        
         if(n < m)
            swap(n, m);
 
       
       if(n == m) {
            if(turn == 0)
                areaV += n * n;
            else
                areaU += n * n;
            break;
        }
    }
}

pair<long long, long long> sim(long long n, long long m) {
    long long areaV = 0, areaU = 0;
    int turn = 0;

    if(n < m)
        swap(n, m);
    
    calcOutcome(n, m, turn, areaV, areaU);
    return {areaV, areaU};
}
 
int main(){
    long long p, q;
    cin >> p >> q;
    
    long long sum = p + q;
 
    for (long long d = 1; d * d <= sum; d++) {
        if (sum % d != 0) continue;
        
        long long m = d, n = sum / d;
        if(n < m) swap(n, m);
        auto simulated = sim(n, m);
        if (simulated.first == p && simulated.second == q) {
            cout << n << " " << m;
            return 0;
        }
        
        if (d * d != sum) {
            long long m2 = sum / d, n2 = d;
            if(n2 < m2) swap(n2, m2);
            auto outcome = sim(n2, m2);
            if (outcome.first == p && outcome.second == q) {
                cout << n2 << " " << m2 << "\n";
                return 0;
            }
        }
    }
    
    cout << -1;
    return 0;
}
