#include <iomanip>
#include <iostream>
#include <valarray>
using namespace std;

bool test_solution(long long n, long long m, long long p, long long q,
                   bool print_it = false) {
  long long players[2];
  players[0] = 0;
  players[1] = 0;

  int player_next = 0;  // 0 - first player; 1 - second player

  long long area = n * m;

  while (area != 0) {
    if (n < m) {
      players[player_next] += pow(n, 2);
      area -= pow(n, 2);
      m -= n;

      player_next = player_next == 0 ? 1 : 0;
    } else {
      players[player_next] += pow(m, 2);
      area -= pow(m, 2);
      n -= m;

      player_next = player_next == 0 ? 1 : 0;
    }
  }

  if (print_it) {
    cout << "players: " << players[0] << ' ' << players[1] << endl;
  }

  return p == players[0] && q == players[1];
}

int main() {
  long long p, q;
  cin >> p >> q;

  int sum_val = p + q;

  // solution
  long long n = sqrt(sum_val);
  long long m = sum_val / n;

  // cout << "area: " << n << ' ' << m << endl;

  bool ans = test_solution(n, m, p, q);

  int loop_count;

  while (!ans) {
    if (loop_count == 100) {
      break;
    }

    n--;
    if (n == 0) {
      break;
    }

    m = sum_val / n;

    // cout << "area: " << n << ' ' << m << endl;

    ans = test_solution(n, m, p, q);
  }

  if (ans) {
    cout << n << ' ' << m << endl;
  } else {
    cout << -1 << endl;
  }
  loop_count++;
}