
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<pll, ll> plll;
typedef pair<pll, pll> ppll;
const ll SIZ = (ll)(1e5 + 5), LONGBOI = (ll)(1e12 + 5);
mt19937 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

struct str {
    ll p1, d1;
    ll p2, d2;
};

ll n, v1, v2, distBetweenMainPoints;
ll used[SIZ];
str p0;
pll p1, p2;
vector<ll> roads[SIZ];

bool markTheWay(ll we, ll par, ll need) {
    if (need == 0 || we == 0) return false;
    if (we == need) {
        used[we] = 1;
        return true;
    }
    for (auto x : roads[we]) {
        if (x == par) continue;
        if (markTheWay(x, we, need)) {
            used[we] = 1;
            return true;
        }
    }
    return false;
}

str find2MainPoints(ll we, ll par, ll dep) {
    str k, ans;
    ans.d1 = dep; ans.p1 = we;
    ans.d2 = 0; ans.p2 = 0;
    for (auto x : roads[we]) {
        if (x == par) continue;
        k = find2MainPoints(x, we, dep + 1);
        if (k.d1 > ans.d1) {
            ans.p1 = k.p1; ans.d1 = k.d1;
            ans.p2 = k.p2; ans.d2 = k.d2;
        }
        else if (k.d1 == ans.d1) {
            ans.p2 = k.p1; ans.d2 = k.d1;
        }
    }
    return ans;
}

plll findThePoints(ll we, ll par, ll dep, set<ll> &toforget) {
    if (we == 0) return { { 0, 0 }, 0 };
    plll k, ans;
    ans = { { 0, 0 }, 0 };
    if (used[we] == 0) ans.second++;
    pll ver;
    ver = { dep, we };
    ans.first = ver;
    for (auto x : roads[we]) {
        if (x == par || toforget.count(x)) continue;
        k = findThePoints(x, we, dep + 1, toforget);
        if (k.first.first > ver.first) {
            ans = k;
            if (used[we] == 0) ans.second++;
            ver = ans.first;
        }
        else if (k.first.first == ver.first && k.second > ans.second) {
            ans = k;
            if (used[we] == 0) ans.second++;
            ver = ans.first;
        }
    }

    if(used[we] == 0) ans.second++;

    //cout << "we = " << we << " par = " << par << " depth = " << dep << " returning = ";
    //cout << "{" << ans.d1 << ", " << ans.p1 << "} {" << ans.d2 << ", " << ans.p2 << "}" << endl;
    return ans;
}

ll dfsDist(ll we, ll par, ll need, ll dep) {
    if (need == 0) return 0;
    ll ans = 0;
    if (we == need) return dep;
    for (auto x : roads[we]) {
        if (x == par) continue;
        ans = max(ans, dfsDist(x, we, need, dep + 1));
    }
    return ans;
}

bool dfsWriteAns(ll we, ll par, ll need) {
    if (need == 0 || we == 0) return 0;
    ll ans = 0;
    if (we == need) {
        cout << we << " ";
        return true;
    }
    for (auto x : roads[we]) {
        if (x == par) continue;
        if (dfsWriteAns(x, we, need)) {
            cout << we << " ";
            return true;
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> v1 >> v2;
        roads[v1].push_back(v2);
        roads[v2].push_back(v1);
    }
    ll root = 1, maxroads = 0;
    //for (int i = 1; i <= n; i++) {
    //    if (roads[i].size() > maxroads) {
    //        root = i; maxroads = roads[i].size();
    //    }
    //}

    p0 = find2MainPoints(root, root, 1);


    set<ll> toforget; toforget.clear();
    distBetweenMainPoints = dfsDist(p0.p1, p0.p1, p0.p2, 1);
    toforget.insert(p0.p2);
    p1 = findThePoints(p0.p1, p0.p1, 1, toforget).first; toforget.clear();
    markTheWay(p0.p1, p0.p1, p1.second);

    toforget.insert(p0.p1); toforget.insert(p1.second);
    p2 = findThePoints(p0.p2, p0.p2, 1, toforget).first; toforget.clear();

    pll p3;
    toforget.insert(p0.p1);
    p3 = findThePoints(p0.p2, p0.p2, 1, toforget).first; toforget.clear();
    if (p3.first > p2.first) p2 = p3;
    //cout << "POINTS (dep, num) : point1 = {" << p0.d1 << ", " << p0.p1 << "} point2 = {" << p0.d2 << ", " << p0.p2 << "}" << endl;
    //cout << "distance Between this deez points = " << distBetweenMainPoints << endl;
    //cout << "POINTS FOR 1 POINT : " << endl;
    //cout << "POINTS (dep, num) : point1 = {" << p1.first << ", " << p1.second << "}" << endl;
    //cout << "POINTS FOR 2 POINT : " << endl;
    //cout << "POINTS (dep, num) : point1 = {" << p2.first << ", " << p2.second << "}" << endl;



    ll distAns = p1.first;
    if (distAns > p2.first) {
        p2 = p1;
        p0.p2 = p0.p1;
    }
    if (distAns < p2.first) {
        distAns = p2.first;
        p1 = p2;
        p0.p1 = p0.p2;
    }

    if (distAns < distBetweenMainPoints) {
        cout << distBetweenMainPoints << endl;
        dfsWriteAns(p0.p1, p0.p1, p0.p2); cout << endl;
        dfsWriteAns(p0.p1, p0.p1, p0.p2); cout << endl;
        return 0;
    }


    cout << distAns << endl;
    dfsWriteAns(p0.p1, p0.p1, p1.second); cout << endl;
    dfsWriteAns(p0.p2, p0.p2, p2.second); cout << endl;
    return 0;
}