#include <iostream>
#include <vector>
#include <set>

using namespace std;

// Відображення цифр у вигляді сірникового коду
vector<int> matchstick = {
    0b1111110, // 0
    0b0110000, // 1
    0b1101101, // 2
    0b1111001, // 3
    0b0110011, // 4
    0b1011011, // 5
    0b1011111, // 6
    0b1110000, // 7
    0b1111111, // 8
    0b1111011  // 9
};

// Генерація можливих цифр при зміні одного сірника
set<int> generate_options(int digit) {
    set<int> options;
    int original = matchstick[digit];
    for (int i = 0; i < 7; ++i) {
        int toggled = original ^ (1 << i);
        for (int new_digit = 0; new_digit <= 9; ++new_digit) {
            if (matchstick[new_digit] == toggled) {
                options.insert(new_digit);
            }
        }
    }
    return options;
}

void solve() {
    int a, b, c;
    cin >> a >> b >> c;
    if (a + b == c) {
        cout << "Yes\n";
        return;
    }
    
    set<int> a_options = generate_options(a);
    set<int> b_options = generate_options(b);
    
    for (int new_a : a_options) {
        if (new_a + b == c) {
            cout << "Yes\n";
            return;
        }
    }
    for (int new_b : b_options) {
        if (a + new_b == c) {
            cout << "Yes\n";
            return;
        }
    }
    cout << "No\n";
}

int main() {
    solve();
    return 0;
}
