#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef vector<int> vi;

tuple<int, vi> bfs(int start, int n, vector<vi> &adj) {
    queue<int> q;
    vector<int> dist(n + 1, -1), parent(n + 1, -1);
    q.push(start);
    dist[start] = 0;
    int farthest = start;
    
    while (!q.empty()) {
        int u = q.front(); q.pop();
        for (int v : adj[u]) {
            if (dist[v] == -1) {
                dist[v] = dist[u] + 1;
                parent[v] = u;
                q.push(v);
                if (dist[v] > dist[farthest]) farthest = v;
            }
        }
    }
    
    vi path;
    for (int v = farthest; v != -1; v = parent[v]) {
        path.push_back(v);
    }
    reverse(path.begin(), path.end());
    return {dist[farthest], path};
}

int main() {
    int n;
    cin >> n;
    vector<vi> adj(n + 1);
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        adj[x].push_back(y);
        adj[y].push_back(x);
    }
    
    auto [_, path1] = bfs(1, n, adj);
    auto [diameter, path2] = bfs(path1.back(), n, adj);
    
    vi covered(n + 1, 0);
    for (int v : path2) covered[v] = 1;
    
    int second_start = -1;
    for (int v : path2) {
        for (int u : adj[v]) {
            if (!covered[u]) {
                second_start = u;
                break;
            }
        }
        if (second_start != -1) break;
    }
    
    vi path3;
    if (second_start != -1) {
        tie(_, path3) = bfs(second_start, n, adj);
    } else {
        path3 = path2;
    }
    
    cout << path2.size() << "\n";
    for (int v : path2) cout << v << " ";
    cout << "\n";
    for (int v : path3) cout << v << " ";
    cout << "\n";
    
    return 0;
}